function [f,gr] = optimal_l(x,i,t,a,a0,al,all,alm,alk,am,amm,amk,ak,akk,phiz,sigma1,sigma2,sigma3,p_l,p_ll,p_m,l,k,z,e,ed_draws,g1e)
% Calculate objective f
%f=-mean(exp(((sigma1+1)/sigma1)*(a0+a(i,t)+al*x(1)+all*x(1).*x(1)+alm*x(1).*x(2)+alk*x(1).*k(i,t)+am*x(2)+amm*x(2).*x(2)+amk*x(2).*k(i,t)+ak*k(i,t)+akk*k(i,t).*k(i,t))-(1/sigma1)*(g1e*e(i,t-1)+squeeze(ed_draws(i,t,:))+phiz*z(i,t-1)))-p_l*exp(x(1))-p_ll*(exp(x(1))./exp(l(i,t-1))-1).^2-p_m*exp(x(2)));
qq=(a0+a(i,t)+al*x(1)+all*x(1).*x(1)+alm*x(1).*x(2)+alk*x(1).*k(i,t)+am*x(2)+amm*x(2).*x(2)+amk*x(2).*k(i,t)+ak*k(i,t)+akk*k(i,t).*k(i,t));

f=-mean(exp(((sigma1+1)/sigma1)*qq ...
+((sigma2)/sigma1)*qq.^2 ...
+((sigma3)/sigma1)*qq.^3 ...
-(1/sigma1)*(g1e*e(i,t-1)+phiz*z(i,t-1)+squeeze(ed_draws(i,t,:)))) ...
-p_l*exp(x(1))-p_ll*(exp(x(1))./exp(l(i,t-1))-1).^2-p_m*exp(x(2)))+1/exp(x(1))+1/exp(x(2));

%f=-sum(exp(((sigma1+1)/sigma1)*(a0+a(i,t)+al*x(1)+all*x(1).*x(1)+alm*x(1).*x(2)+alk*x(1).*k(i,t)+am*x(2)+amm*x(2).*x(2)+amk*x(2).*k(i,t)+ak*k(i,t)+akk*k(i,t).*k(i,t)) ...
%+((sigma2)/sigma1)*(a0+a(i,t)+al*x(1)+all*x(1).*x(1)+alm*x(1).*x(2)+alk*x(1).*k(i,t)+am*x(2)+amm*x(2).*x(2)+amk*x(2).*k(i,t)+ak*k(i,t)+akk*k(i,t).*k(i,t)).^2 ...
%+((sigma3)/sigma1)*(a0+a(i,t)+al*x(1)+all*x(1).*x(1)+alm*x(1).*x(2)+alk*x(1).*k(i,t)+am*x(2)+amm*x(2).*x(2)+amk*x(2).*k(i,t)+ak*k(i,t)+akk*k(i,t).*k(i,t)).^3 ...
%-(1/sigma1)*(g1e*e(i,t-1)+squeeze(ed_draws(i,t,:))+phiz*z(i,t-1)))-p_l*exp(x(1))-p_ll*(exp(x(1))./exp(l(i,t-1))-1).^2-p_m*exp(x(2)));
dfdq=((sigma1+1)/sigma1)+2*((sigma2)/sigma1)*qq+2*((sigma3)/sigma1)*qq.^2;
dqdm=(alm*x(1)+am+amm*x(2)+amk.*k(i,t));
dqdl=(al+all*x(1)+alm.*x(2)+alk.*k(i,t));

if nargout > 1 % gradient required
%    gr=[sum(-(exp(((sigma1+1)/sigma1)*(a0+a(i,t)+al*x(1)+all*x(1).*x(1)+alm*x(1).*x(2)+alk*x(1).*k(i,t)+am*x(2)+amm*x(2).*x(2)+amk*x(2).*k(i,t)+ak*k(i,t)+akk*k(i,t).*k(i,t))-(1/sigma1)*(g1e*e(i,t-1)+squeeze(ed_draws(i,t,:))+phiz*z(i,t-1))).*((sigma1+1)/sigma1)*(al+all*x(1)+alm.*x(2)+alk.*k(i,t))-p_l*exp(x(1))-2*p_ll*(exp(x(1))./exp(l(i,t-1))-1).^2));
%        sum(-(exp(((sigma1+1)/sigma1)*(a0+a(i,t)+al*x(1)+all*x(1).*x(1)+alm*x(1).*x(2)+alk*x(1).*k(i,t)+am*x(2)+amm*x(2).*x(2)+amk*x(2).*k(i,t)+ak*k(i,t)+akk*k(i,t).*k(i,t))-(1/sigma1)*(g1e*e(i,t-1)+squeeze(ed_draws(i,t,:))+phiz*z(i,t-1))).*((sigma1+1)/sigma1)*(alm*x(1)+am+amm*x(2)+amk.*k(i,t))-p_m*exp(x(2))))];
    gr=[(-mean(exp(((sigma1+1)/sigma1)*qq+((sigma2)/sigma1)*qq.^2+((sigma3)/sigma1)*qq.^3-(1/sigma1)*(g1e*e(i,t-1)+squeeze(ed_draws(i,t,:))+phiz*z(i,t-1))).*dfdq.*dqdl-p_l*exp(x(1))-2*p_ll*exp(x(1))./(exp(l(i,t-1))-1).^2))-1/exp(x(1));
        (-mean(exp(((sigma1+1)/sigma1)*qq+((sigma2)/sigma1)*qq.^2+((sigma3)/sigma1)*qq.^3-(1/sigma1)*(g1e*e(i,t-1)+squeeze(ed_draws(i,t,:))+phiz*z(i,t-1))).*dfdq.*dqdm-p_m*exp(x(2))))-1/exp(x(2))];
end



