function [f,gr] = optimal_m(x,i,t,a,a0,al,all,alm,alk,am,amm,amk,ak,akk,phiz,sigma1,sigma2,sigma3,p_l,p_ll,p_m,l,k,z,e)
% Calculate objective f
%f=(-(exp(((sigma1+1)/sigma1)*(a0+a(i,t)+al*l(i,t)+all*l(i,t).*l(i,t)+alm*l(i,t).*x(1)+alk*l(i,t).*k(i,t)+am*x(1)+amm*x(1).*x(1)+amk*x(1).*k(i,t)+ak*k(i,t)+akk*k(i,t).*k(i,t))-(1/sigma1)*(e(i,t)+phiz*z(i,t-1)))-p_l*exp(l(i,t))-p_ll*(exp(l(i,t))./exp(l(i,t-1))-1).^2-p_m*exp(x(1))));
qq=(a0+a(i,t)+al*l(i,t)+all*l(i,t).*l(i,t)+alm*l(i,t).*x(1)+alk*l(i,t).*k(i,t)+am*x(1)+amm*x(1).*x(1)+amk*x(1).*k(i,t)+ak*k(i,t)+akk*k(i,t).*k(i,t));
f=(-(exp(((sigma1+1)/sigma1)*qq ...
+((sigma2)/sigma1)*qq.^2 ...
+((sigma3)/sigma1)*qq.^3 ...
-(1/sigma1)*(e(i,t)+phiz*z(i,t-1)))-p_l*exp(l(i,t))-p_ll*(exp(l(i,t))./exp(l(i,t-1))-1).^2-p_m*exp(x(1))));

%-(1/sigma1)*(e(i,t)+phiz*z(i,t-1)))-p_l*exp(l(i,t))-p_ll*(exp(l(i,t))./exp(l(i,t-1))-1).^2-p_m*exp(x(1))));

dfdq=((sigma1+1)/sigma1)+2*((sigma2)/sigma1)*qq+2*((sigma3)/sigma1)*qq.^2;
dqdm=(alm*l(i,t)+am+amm*x(1)+amk.*k(i,t));
%f=(-(exp(((sigma1+1)/sigma1)*(a0+a(i,t)+al*l(i,t)+all*l(i,t).*l(i,t)+alm*l(i,t).*x(1)+alk*l(i,t).*k(i,t)+am*x(1)+amm*x(1).*x(1)+amk*x(1).*k(i,t)+ak*k(i,t)+akk*k(i,t).*k(i,t)) ...
%+((sigma2)/sigma1)*(a0+a(i,t)+al*l(i,t)+all*l(i,t).*l(i,t)+alm*l(i,t).*x(1)+alk*l(i,t).*k(i,t)+am*x(1)+amm*x(1).*x(1)+amk*x(1).*k(i,t)+ak*k(i,t)+akk*k(i,t).*k(i,t)).^2 ...
%+((sigma3)/sigma1)*(a0+a(i,t)+al*l(i,t)+all*l(i,t).*l(i,t)+alm*l(i,t).*x(1)+alk*l(i,t).*k(i,t)+am*x(1)+amm*x(1).*x(1)+amk*x(1).*k(i,t)+ak*k(i,t)+akk*k(i,t).*k(i,t)).^3 ...
%-(1/sigma1)*(e(i,t)+phiz*z(i,t-1)))-p_l*exp(l(i,t))-p_ll*(exp(l(i,t))./exp(l(i,t-1))-1).^2-p_m*exp(x(1))));

if nargout > 1 % gradient required
%	gr=(-(exp(((sigma1+1)/sigma1)*(a0+a(i,t)+al*l(i,t)+all*l(i,t).*l(i,t)+alm*l(i,t).*x(1)+am*x(1)+amm*x(1).*x(1)+amk*x(1).*k(i,t)+ak*k(i,t)+akk*k(i,t).*k(i,t))-(1/sigma1)*(e(i,t)+phiz*z(i,t-1))).*((sigma1+1)/sigma1).*(alm*l(i,t)+am+amm*x(1)+amk.*k(i,t))-p_m*exp(x(1))));
    gr=-(exp(((sigma1+1)/sigma1)*qq+((sigma2)/sigma1)*qq.^2+((sigma3)/sigma1)*qq.^3-(1/sigma1)*(e(i,t)+phiz*z(i,t-1))).*dfdq.*dqdm-p_m*exp(x(1)));
end